using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;
using System.Text.RegularExpressions;

namespace r8cprog_GUI {
    public partial class MainForm : Form {

        private string R8cprog_exe;
        private string CurrrentDirectory;

        // vOXo[pfQ[g
        private delegate void delegateProgressBar(int v);

        /// <summary>
        /// vOXo[̍őlݒ
        /// </summary>
        /// <param name="max"></param>
        private void SetProgressMax(int max) {
            toolStripProgressBar.Maximum = max;
        }

        /// <summary>
        /// vOXo[ől\ɂ
        /// </summary>
        /// <returns></returns>
        private void SetProgressFull(int dummy) {
            toolStripProgressBar.Value = toolStripProgressBar.Maximum;
            //toolStripProgressBar.Refresh();
        }

        /// <summary>
        /// vOXo[̒lݒ
        /// </summary>
        /// <param name="value"></param>
        private void SetProgressValue(int value) {
            if (value < toolStripProgressBar.Maximum) {
                toolStripProgressBar.Value = value;
            } else {
                toolStripProgressBar.Value = toolStripProgressBar.Maximum;
            }
            //toolStripProgressBar.Refresh();
        }

        /// <summary>
        /// vOXo[̒lZ
        /// </summary>
        /// <param name="value"></param>
        private void SetProgressAdd(int value) {
            if (toolStripProgressBar.Value + value < toolStripProgressBar.Maximum) {
                toolStripProgressBar.Value += value;
            } else {
                toolStripProgressBar.Value = toolStripProgressBar.Maximum;
            }
            //toolStripProgressBar.Refresh();
        }

        /// <summary>
        /// Chip Erase {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ChipEraseButton_Click(object sender, EventArgs e) {

            if (MessageBox.Show("Chip Erase OK ?",
                this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
                != DialogResult.Yes) {
                return;
            }
            ExecCommand("--erase-chip", 50);
        }

        /// <summary>
        /// Erase {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void EraseButton_Click(object sender, EventArgs e) {

            if (MessageBox.Show("Erase OK ?",
                this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
                != DialogResult.Yes) {
                return;
            }
            if ((MotFileTextBox.Text.Length == 0) ||
                (!File.Exists(MotFileTextBox.Text))) {
                ExecCommand("--erase-all", 50);
            } else {
                ExecCommand("-e " + MotFileTextBox.Text, 50);
            }
        }

        /// <summary>
        /// Write {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void WriteButton_Click(object sender, EventArgs e) {

            if ((MotFileTextBox.Text.Length == 0) ||
                (!File.Exists(MotFileTextBox.Text))) {
                MessageBox.Show("mot File not found.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                MotFileButton.Focus();
                return;
            }
            ExecCommand("-w " + MotFileTextBox.Text, 50);
        }

        /// <summary>
        /// Verify {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void VerifyButton_Click(object sender, EventArgs e) {

            if ((MotFileTextBox.Text.Length == 0) ||
                (!File.Exists(MotFileTextBox.Text))) {
                MessageBox.Show("mot File not found.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                MotFileButton.Focus();
                return;
            }
            ExecCommand("-v " + MotFileTextBox.Text, 50);
        }

        /// <summary>
        /// Erase - Write - Verify {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void EraseWriteVerifyButton_Click(object sender, EventArgs e) {

            if ((MotFileTextBox.Text.Length == 0) ||
                (!File.Exists(MotFileTextBox.Text))) {
                MessageBox.Show("mot File not found.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                MotFileButton.Focus();
                return;
            }
            ExecCommand("-e -w -v " + MotFileTextBox.Text, 150);
        }

        /// <summary>
        /// MOTt@Cw{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MotFileButton_Click(object sender, EventArgs e) {

            OpenFileDialog.CheckFileExists = false;
            OpenFileDialog.AddExtension = true;
            OpenFileDialog.DefaultExt = "mot";
            OpenFileDialog.Filter = "Motolora S File(*.mot)|*.mot|All File(*.*)|*.*";
            OpenFileDialog.FileName = "";
            if (OpenFileDialog.ShowDialog() == DialogResult.OK) {
                if (OpenFileDialog.FileName.Length > 0) {
                    MotFileTextBox.Text = OpenFileDialog.FileName;
                }
            }
        }

        /// <summary>
        /// Load ID File {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e) {

            OpenFileDialog.CheckFileExists = true;
            OpenFileDialog.AddExtension = true;
            OpenFileDialog.DefaultExt = "id";
            OpenFileDialog.Filter = "ID File(*.id)|*.id|All File(*.*)|*.*";
            OpenFileDialog.FileName = "";
            if (OpenFileDialog.ShowDialog() == DialogResult.OK) {
                if (OpenFileDialog.FileName.Length > 0) {
                    StreamReader sr = new StreamReader(OpenFileDialog.FileName);
                    try {
                        Regex reg = new Regex("^-ID#([0-9A-Fa-f]{14})");
                        Match m = reg.Match(sr.ReadLine());
                        if (m.Success) {
                            ID1TextBox.Text = m.Groups[1].Value.Substring(0, 2);
                            ID2TextBox.Text = m.Groups[1].Value.Substring(2, 2);
                            ID3TextBox.Text = m.Groups[1].Value.Substring(4, 2);
                            ID4TextBox.Text = m.Groups[1].Value.Substring(6, 2);
                            ID5TextBox.Text = m.Groups[1].Value.Substring(8, 2);
                            ID6TextBox.Text = m.Groups[1].Value.Substring(10, 2);
                            ID7TextBox.Text = m.Groups[1].Value.Substring(12, 2);
                        }
                        sr.Close();
                    } catch (Exception ex) {
                        sr.Close();
                        MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
            }
        }

        /// <summary>
        /// ALL FFh {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e) {
            ID1TextBox.Text = "FF";
            ID2TextBox.Text = "FF";
            ID3TextBox.Text = "FF";
            ID4TextBox.Text = "FF";
            ID5TextBox.Text = "FF";
            ID6TextBox.Text = "FF";
            ID7TextBox.Text = "FF";
        }

        /// <summary>
        /// ALL 00h {^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e) {
            ID1TextBox.Text = "00";
            ID2TextBox.Text = "00";
            ID3TextBox.Text = "00";
            ID4TextBox.Text = "00";
            ID5TextBox.Text = "00";
            ID6TextBox.Text = "00";
            ID7TextBox.Text = "00";
        }
        
        /// <summary>
        /// Exit{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExitButton_Click(object sender, EventArgs e) {
            Application.Exit();
        }

        /// <summary>
        /// tH[RXgN^
        /// </summary>
        public MainForm() {
            InitializeComponent();

            string[] ports;
            ports = SerialPort.GetPortNames();  // LȃVA|[gSĎ擾

            // |[gꗗăR{{bNXɃZbg
            PortComboBox.Items.Add("");     // I
            foreach (string p in ports) {
                if (p.Length > 0) {
                    PortComboBox.Items.Add(p);
                }
            }

            // JgfBNg擾
            CurrrentDirectory = Directory.GetCurrentDirectory();
            if (CurrrentDirectory.Substring(0, 1) == "/") {
                R8cprog_exe = CurrrentDirectory + "/r8cprog";           // MONO r8cprog
                int n = 0;
                while (File.Exists("/dev/ttyACM" + n.ToString())) {
                    PortComboBox.Items.Add("/dev/ttyACM" + n.ToString());
                    n++;
                }
                n = 0;
                while (File.Exists("/dev/ttyUSB" + n.ToString())) {
                    PortComboBox.Items.Add("/dev/ttyUSB" + n.ToString());
                    n++;
                }
            } else {
                R8cprog_exe = CurrrentDirectory + "\\r8cprog.exe";    // JgfBNg r8cprog.exe
            }

            // ^Cgo[
            this.Text += Application.ProductVersion;
            this.Text = this.Text.Substring(0, this.Text.LastIndexOf('.')); // o[Wԍ폜

            // r8cprog擾
            r8cprog_info();
        }

        /// <summary>
        /// tH[ Load
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MainForm_Load(object sender, EventArgs e) {
            int i;
            for (i = 0; i < PortComboBox.Items.Count; i++) {
                if ((string)PortComboBox.Items[i] == Properties.Settings.Default.Port) {
                    PortComboBox.SelectedIndex = i;
                    break;
                }
            }
            for (i = 0; i < SpeedComboBox.Items.Count; i++){
                if ((string)SpeedComboBox.Items[i] == Properties.Settings.Default.Speed) {
                    SpeedComboBox.SelectedIndex = i;
                    break;
                }
            }
            for (i = 0; i < ProgrammerComboBox.Items.Count; i++) {
                if ((string)ProgrammerComboBox.Items[i] == Properties.Settings.Default.Programmer) {
                    ProgrammerComboBox.SelectedIndex = i;
                    break;
                }
            }
            for (i = 0; i < DeviceComboBox.Items.Count; i++) {
                if ((string)DeviceComboBox.Items[i] == Properties.Settings.Default.Device) {
                    DeviceComboBox.SelectedIndex = i;
                    break;
                }
            }
        }

        /// <summary>
        /// tH[ Closed
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MainForm_FormClosed(object sender, FormClosedEventArgs e) {
            // [U[ݒۑ
            if (PortComboBox.SelectedIndex > 0)
                Properties.Settings.Default.Port = PortComboBox.SelectedItem.ToString();
            if (SpeedComboBox.SelectedIndex > 0)
                Properties.Settings.Default.Speed = SpeedComboBox.SelectedItem.ToString();
            if (ProgrammerComboBox.SelectedIndex > 0)
                Properties.Settings.Default.Programmer = ProgrammerComboBox.SelectedItem.ToString();
            if (DeviceComboBox.SelectedIndex > 0)
                Properties.Settings.Default.Device = DeviceComboBox.SelectedItem.ToString();
            Properties.Settings.Default.Save();
        }

        /// <summary>
        /// r8cprog.exe Ăяo
        /// </summary>
        /// <param name="arg"></param>
        private System.Diagnostics.Process r8cprog(string arg) {

            if (!File.Exists(R8cprog_exe)) return null;

            System.Diagnostics.Process prc;
            try {
                System.Diagnostics.ProcessStartInfo psi = new System.Diagnostics.ProcessStartInfo();
                psi.FileName = R8cprog_exe;
                psi.RedirectStandardOutput = true;  // Wo͂荞
                psi.CreateNoWindow = true;          // EChE\Ȃ
                psi.UseShellExecute = false;        // K{
                psi.Arguments = arg;                // 
                psi.WorkingDirectory = CurrrentDirectory;   // JgfBNg
                prc = System.Diagnostics.Process.Start(psi);
            } catch {
                prc = null;
            }
            return prc;
        }

        /// <summary>
        /// r8cprog.exe擾
        /// </summary>
        private void r8cprog_info() {
            string line;

            System.Diagnostics.Process prc = r8cprog("--programmer-list");  //  vO}ꗗ
            if (prc == null) return;

            ProgrammerComboBox.Items.Clear();
            ProgrammerComboBox.Items.Add("");
            if (!prc.StandardOutput.EndOfStream) {
                line = prc.StandardOutput.ReadLine();   // 1sڂ͕sv
            }
            while (!prc.StandardOutput.EndOfStream) {
                line = prc.StandardOutput.ReadLine();
                ProgrammerComboBox.Items.Add(line);
            }
            prc.WaitForExit();
            prc.Close();

            prc = r8cprog("--device-list");  //  foCXꗗ
            if (prc == null) return;

            Regex reg = new Regex("^(\\S+)\\s+(\\S+)\\s+(\\S+)\\s+(\\S+)\\s+(\\S+)");

            DeviceComboBox.Items.Clear();
            DeviceComboBox.Items.Add("");
            if (!prc.StandardOutput.EndOfStream) {
                line = prc.StandardOutput.ReadLine();   // 1sڂ͕sv
            }
            while (!prc.StandardOutput.EndOfStream) {
                line = prc.StandardOutput.ReadLine();
                Match m = reg.Match(line);
                if (m.Success) {
                    DeviceComboBox.Items.Add(m.Result("$1 $2 ($3/$4/$5)$'"));
                }
            }
            prc.WaitForExit();
            prc.Close();
        }

        /// <summary>
        /// r8cprog.exë̋ʕ쐬
        /// </summary>
        /// <returns></returns>
        private string GetArg() {
            string arg = "";

            if (PortComboBox.SelectedIndex > 0) {
                arg += " --port=" + PortComboBox.SelectedItem.ToString();
            }
            if (SpeedComboBox.SelectedIndex > 0) {
                string speed = SpeedComboBox.SelectedItem.ToString();
                if (speed.IndexOf(' ') > 0) {
                    speed = speed.Substring(0, speed.IndexOf(' '));
                }
                arg += " --speed=" + speed;
            }
            if (ProgrammerComboBox.SelectedIndex > 0) {
                string programmer = ProgrammerComboBox.SelectedItem.ToString();
                Regex reg = new Regex("^(\\w+)");
                Match m = reg.Match(programmer);
                if (m.Success) {
                    programmer = m.Groups[1].Value;
                }
                arg += " --programmer=" + programmer;
            }
            if (DeviceComboBox.SelectedIndex > 0) {
                string device = DeviceComboBox.SelectedItem.ToString();
                Regex reg = new Regex("^\\S+\\s+(\\w+)");
                Match m = reg.Match(device);
                if (m.Success) {
                    arg += " --device=" + m.Groups[1].Value;
                }
            }
            if (CheckIDTextBox(ID1TextBox) == false) return "";
            if (CheckIDTextBox(ID2TextBox) == false) return "";
            if (CheckIDTextBox(ID3TextBox) == false) return "";
            if (CheckIDTextBox(ID4TextBox) == false) return "";
            if (CheckIDTextBox(ID5TextBox) == false) return "";
            if (CheckIDTextBox(ID6TextBox) == false) return "";
            if (CheckIDTextBox(ID7TextBox) == false) return "";

            arg += " --id="
                + ID1TextBox.Text + ":"
                + ID2TextBox.Text + ":"
                + ID3TextBox.Text + ":"
                + ID4TextBox.Text + ":"
                + ID5TextBox.Text + ":"
                + ID6TextBox.Text + ":"
                + ID7TextBox.Text;

            return arg;
        }

        /// <summary>
        /// ID TextBox̃`FbN
        /// </summary>
        /// <param name="tx"></param>
        /// <returns></returns>
        private bool CheckIDTextBox(TextBox tx) {
            if (tx.Text.Length == 0) {
                MessageBox.Show("Set ID at two HEX characters",
                    this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                tx.Focus();
                return false;
            }
            if (tx.Text.Length == 1) {
                tx.Text = "0" + tx.Text;
            }
            Regex reg = new Regex("^[0-9A-Fa-f]{2}$");
            Match m = reg.Match(tx.Text);
            if (!m.Success) {
                MessageBox.Show("Set ID at two HEX characters",
                    this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                tx.Focus();
                return false;
            }
            return true;
        }

        /// <summary>
        /// r8cprog R}hs
        /// </summary>
        /// <param name="arg">r8cprog̈</param>
        /// <param name="maxProgress">r8cprog̏o͕񒆂 # ̐(=vOXo[̍ől)</param>
        /// <returns>avrdude̖߂l</returns>
        private int ExecCommand(string arg, int maxProgress) {

            System.Windows.Forms.Cursor cur = System.Windows.Forms.Cursor.Current;

            delegateProgressBar prgval = new delegateProgressBar(SetProgressValue);
            delegateProgressBar prgmax = new delegateProgressBar(SetProgressMax);
            delegateProgressBar prgadd = new delegateProgressBar(SetProgressAdd);

            try {
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;   // vJ[\

                // r8cprogN
                string argument = GetArg();
                if (argument == "") throw new Exception("");
                argument += " " + arg;

                System.Diagnostics.Process prc = r8cprog(argument);
                if (prc == null) throw new Exception("Not execute r8cprog.exe");

                StringBuilder sb = new StringBuilder();

                this.Invoke(prgmax, new object[] { maxProgress });
                this.Invoke(prgval, new object[] { 0 });

                while (!prc.StandardOutput.EndOfStream) {
                    int c;
                    c = prc.StandardOutput.Read();
                    // # o͂ꂽvOXo[i߂
                    if ((c == (int)'#') && (toolStripProgressBar.Value < toolStripProgressBar.Maximum)) {
                        this.Invoke(prgadd, new object[] { 1 });
                    }
                    sb.Append((char)c); // o̓bZ[WƂĂ
                }
                prc.WaitForExit();  // I҂

                System.Windows.Forms.Cursor.Current = cur;  // J[\߂

                if (prc.ExitCode != 0){
                    prc.Close();
                    // G[̂ŏo̓bZ[W\
                    System.Media.SystemSounds.Asterisk.Play();  // `CH
                    Form md = new ErrorMessageForm();
                    md.Text = this.Text + " Error";
                    md.Controls["MessageTextBox"].Text = sb.ToString();
                    md.ShowDialog();
                    this.Invoke(prgval, new object[] { 0 });
                    return 1;
                } else {
                    prc.Close();

                    // New ID ǂݍ
                    Regex reg = new Regex("New ID : (\\w+):(\\w+):(\\w+):(\\w+):(\\w+):(\\w+):(\\w+)");
                    Match m = reg.Match(sb.ToString());
                    if (m.Success) {
                        ID1TextBox.Text = m.Groups[1].Value;
                        ID2TextBox.Text = m.Groups[2].Value;
                        ID3TextBox.Text = m.Groups[3].Value;
                        ID4TextBox.Text = m.Groups[4].Value;
                        ID5TextBox.Text = m.Groups[5].Value;
                        ID6TextBox.Text = m.Groups[6].Value;
                        ID7TextBox.Text = m.Groups[7].Value;
                    }
                    
                    // I
                    MessageBox.Show("Finished.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Invoke(prgval, new object[] { 0 });
                    return 0;
                }

            } catch (Exception ex) {
                System.Windows.Forms.Cursor.Current = cur;  // J[\߂
                if (ex.Message.Length > 0){
                    MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                this.Invoke(prgval, new object[] { 0 });
                return 1;
            }
        }

    }
}